
Contribution Guidelines
=======================

**Core ML Open Source Community**

The Core ML open source community welcomes all contributions and ideas to grow the product.

 This could be provided in a couple of ways:

 * Discovering and logging a **bug**, submitting an idea for a **feature request** (or **enhancement** to an existing feature) or asking a **question** through the use of the templates: [coremltools issue](https://github.com/apple/coremltools/issues/new/choose)

 * Submit a **pull request** for additional functionality that you have completed: [coremltools PR](https://github.com/apple/coremltools/pulls)

 * Resolve an existing **issue** found in any of the repositories: [coremltools open issues](https://github.com/apple/coremltools/issues)

Expectations of the Community
---

The contributing guidelines and code of conduct are similar to most open source communities. This includes participating in the community through developing, receiving help and answering questions as well as engaging in a highly motivate, positive environment. 

Additionally, this includes but is not limited to:

* Providing comments that are helpful, motivating and constructive
* Being respectful of others within the community
* Collaborate with others to produce new, useful contributions to the community

## Github Best Practices for Core ML Community

While participating in the Core ML community, to ensure that issues and pull requests are able to be addressed quickly, please ensure that the following is being done:

* Checking to see if your issue already exists
* Following pre-existing templates 
* Promptly replying to any requests or questions posed by others within the community on your issue / PR

## What to expect as a Contributor to Core ML

### Lifecycle of Issues

Once an issue has been submitted it will be triaged and appropriate labels will be added. The issue will then either be slotted in to an upcoming release, commented on for additional information or placed in the backlog for a future release. 

#### Use of templates
There will be a provided template when submitting your issue. Please ensure that this is used and filled in as much as possible to help others in the community in understanding the issue so that they are able to provide a response easily. 

If applicable, please provide the model that was being used when logging the issue, so that the issue is able to be reproduced.

#### Labels
Please check the labels page under each repository for a further description of each label. These labels will be added by Core ML team members depending on need. Typically an issue can be given any of the following labels:

Status → What stage of the process the issue is in (turquoise) 

* Triaged, awaiting response, duplicate, repro needed, investigation or needs discussion

Type  → Issue is classified based on the category it belongs to (red) 

* bug, clarification, docs, enhancement, feature request, perf, question

Release → If the issue is scheduled to be resolved in a specific release, it will be added (yellow)

Other → this may vary depending on the repository

* good first issue, help wanted, CreateML

### Lifecycle of Pull Requests

Any pull request submitted to the repositories will be reviewed by a member of the community and upon approval by a Core ML team member can be merged to the master branch. If you are new to GitHub, please find more information regarding creating pull requests [here](https://help.github.com/en/articles/creating-a-pull-request).

Developing in Core ML
---

Additional information regarding APIs, installation and dependencies and more can be found in each respective repository, in the readme.md file.

* [coremltools](https://github.com/apple/coremltools)
* [onnx-coreml](https://github.com/onnx/onnx-coreml)
* [tf-coreml](https://github.com/tf-coreml/tf-coreml)
